#include <iostream>
using namespace std;

string s;

bool isPalindrome(int i, int j) {
    while (i < j)
     {
        if (s[i] != s[j]) return false;
        i++; j--;
     }
    return true;
}

int rec(int i, int j)
{
    if (i >= j || isPalindrome(i, j)) return 0;

    int r = 1e9;
    for (int k = i; k < j; k++)
     {
        int c = 1 + rec(i, k) + rec(k + 1, j);
        r = min(r, c);
      }
    return r;
}

int main()
{
	std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);

    cin >> s;

    cout << rec(0,s.size()-1) + 1 << endl;
    return 0;
}

